3 # Copyright (c) 2005, Linus Torvalds
4 # Copyright (c) 2005, Junio C Hamano
6 # Clone a repository into a different directory that does not yet exist.
8 # See git-sh-setup why.
12 echo >&2 "Usage: $0 [--template=<template_directory>] [--use-separate-remote] [--reference <reference-repo>] [--bare] [-l [-s]] [-q] [-u <upload-pack>] [--origin <name>] [-n] <repo> [<dir>]"
17 (cd "$1" && (cd .git ; pwd)) 2> /dev/null
20 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
25 # $1 = Remote, $2 = Local
26 curl -nsfL $curl_extra_args "$1" >"$2"
30 # $1 - remote, $2 - local
32 clone_tmp="$GIT_DIR/clone-tmp" &&
33 mkdir -p "$clone_tmp" || exit 1
34 http_fetch "$1/info/refs" "$clone_tmp/refs" || {
35 echo >&2 "Cannot get remote repository information.
36 Perhaps git-update-server-info needs to be run there?"
39 while read sha1 refname
41 name=`expr "z$refname" : 'zrefs/\(.*\)'` &&
45 if test -n "$use_separate_remote" &&
46 branch_name=`expr "z$name" : 'zheads/\(.*\)'`
48 tname="remotes/$origin/$branch_name"
52 git-http-fetch -v -a -w "$tname" "$name" "$1/" || exit 1
53 done <"$clone_tmp/refs"
55 http_fetch "$1/HEAD" "$GIT_DIR/REMOTE_HEAD" ||
56 rm -f "$GIT_DIR/REMOTE_HEAD"
59 # Read git-fetch-pack -k output and store the remote branches.
61 use File::Path qw(mkpath);
62 use File::Basename qw(dirname);
63 my $git_dir = $ARGV[0];
64 my $use_separate_remote = $ARGV[1];
65 my $origin = $ARGV[2];
67 my $branch_top = ($use_separate_remote ? "remotes/$origin" : "heads");
71 my ($sha1, $name, $top) = @_;
72 $name = "$git_dir/refs/$top/$name";
73 mkpath(dirname($name));
79 open FH, "<", "$git_dir/CLONE_HEAD";
81 my ($sha1, $name) = /^([0-9a-f]{40})\s(.*)$/;
82 next if ($name =~ /\^\173/);
83 if ($name eq "HEAD") {
84 open O, ">", "$git_dir/REMOTE_HEAD";
89 if ($name =~ s/^refs\/heads\///) {
90 store($sha1, $name, $branch_top);
93 if ($name =~ s/^refs\/tags\///) {
94 store($sha1, $name, $tag_top);
116 *,-n|*,--no|*,--no-|*,--no-c|*,--no-ch|*,--no-che|*,--no-chec|\
117 *,--no-check|*,--no-checko|*,--no-checkou|*,--no-checkout)
119 *,--na|*,--nak|*,--nake|*,--naked|\
120 *,-b|*,--b|*,--ba|*,--bar|*,--bare) bare=yes ;;
121 *,-l|*,--l|*,--lo|*,--loc|*,--loca|*,--local) use_local=yes ;;
122 *,-s|*,--s|*,--sh|*,--sha|*,--shar|*,--share|*,--shared)
123 local_shared=yes; use_local=yes ;;
124 1,--template) usage ;;
126 shift; template="--template=$1" ;;
129 *,-q|*,--quiet) quiet=-q ;;
130 *,--use-separate-remote)
131 use_separate_remote=t ;;
132 1,--reference) usage ;;
134 shift; reference="$1" ;;
136 reference=`expr "z$1" : 'z--reference=\(.*\)'` ;;
137 *,-o|*,--or|*,--ori|*,--orig|*,--origi|*,--origin)
142 echo >&2 "'$2' is not suitable for an origin name"
145 git-check-ref-format "heads/$2" || {
146 echo >&2 "'$2' is not suitable for a branch name"
149 test -z "$origin_override" || {
150 echo >&2 "Do not give more than one --origin options."
156 1,-u|1,--upload-pack) usage ;;
157 *,-u|*,--upload-pack)
159 upload_pack="--exec=$1" ;;
170 echo >&2 'you must specify a repository to clone.'
174 # --bare implies --no-checkout
175 if test yes = "$bare"
177 if test yes = "$origin_override"
179 echo >&2 '--bare and --origin $origin options are incompatible.'
182 if test t = "$use_separate_remote"
184 echo >&2 '--bare and --use-separate-remote options are incompatible.'
195 # Turn the source into an absolute path if
197 if base=$(get_repo_base "$repo"); then
203 # Try using "humanish" part of source repo if user didn't specify one
204 [ -z "$dir" ] && dir=$(echo "$repo" | sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
205 [ -e "$dir" ] && echo "$dir already exists." && usage
207 D=$(cd "$dir" && pwd) &&
208 trap 'err=$?; cd ..; rm -rf "$D"; exit $err' 0
214 esac && export GIT_DIR && git-init-db ${template+"$template"} || usage
216 if test -n "$reference"
218 if test -d "$reference"
220 if test -d "$reference/.git/objects"
222 reference="$reference/.git"
224 reference=$(cd "$reference" && pwd)
225 echo "$reference/objects" >"$GIT_DIR/objects/info/alternates"
226 (cd "$reference" && tar cf - refs) |
227 (cd "$GIT_DIR/refs" &&
228 mkdir reference-tmp &&
232 echo >&2 "$reference: not a local directory." && usage
236 rm -f "$GIT_DIR/CLONE_HEAD"
238 # We do local magic only when the user tells us to.
239 case "$local,$use_local" in
241 ( cd "$repo/objects" ) || {
242 echo >&2 "-l flag seen but $repo is not local."
246 case "$local_shared" in
248 # See if we can hardlink and drop "l" if not.
249 sample_file=$(cd "$repo" && \
250 find objects -type f -print | sed -e 1q)
252 # objects directory should not be empty since we are cloning!
253 test -f "$repo/$sample_file" || exit
256 if ln "$repo/$sample_file" "$GIT_DIR/objects/sample" 2>/dev/null
260 rm -f "$GIT_DIR/objects/sample" &&
262 find objects -depth -print | cpio -pumd$l "$GIT_DIR/" || exit 1
265 mkdir -p "$GIT_DIR/objects/info"
266 echo "$repo/objects" >> "$GIT_DIR/objects/info/alternates"
269 git-ls-remote "$repo" >"$GIT_DIR/CLONE_HEAD" || exit 1
274 rsync $quiet -av --ignore-existing \
275 --exclude info "$repo/objects/" "$GIT_DIR/objects/" ||
277 # Look at objects/info/alternates for rsync -- http will
278 # support it natively and git native ones will do it on the
279 # remote end. Not having that file is not a crime.
280 rsync -q "$repo/objects/info/alternates" \
281 "$GIT_DIR/TMP_ALT" 2>/dev/null ||
282 rm -f "$GIT_DIR/TMP_ALT"
283 if test -f "$GIT_DIR/TMP_ALT"
286 . git-parse-remote &&
287 resolve_alternates "$repo" <"$GIT_DIR/TMP_ALT" ) |
290 case "$alt" in 'bad alternate: '*) die "$alt";; esac
292 '') echo >&2 "Getting alternate: $alt" ;;
294 rsync $quiet -av --ignore-existing \
295 --exclude info "$alt" "$GIT_DIR/objects" || exit
297 rm -f "$GIT_DIR/TMP_ALT"
299 git-ls-remote "$repo" >"$GIT_DIR/CLONE_HEAD" || exit 1
301 https://*|http://*|ftp://*)
302 if test -z "@@NO_CURL@@"
304 clone_dumb_http "$repo" "$D"
306 echo >&2 "http transport not supported, rebuild Git with curl support"
311 cd "$D" && case "$upload_pack" in
312 '') git-fetch-pack --all -k $quiet "$repo" ;;
313 *) git-fetch-pack --all -k $quiet "$upload_pack" "$repo" ;;
314 esac >"$GIT_DIR/CLONE_HEAD" || {
315 echo >&2 "fetch-pack from '$repo' failed."
322 test -d "$GIT_DIR/refs/reference-tmp" && rm -fr "$GIT_DIR/refs/reference-tmp"
324 if test -f "$GIT_DIR/CLONE_HEAD"
326 # Read git-fetch-pack -k output and store the remote branches.
327 @@PERL@@ -e "$copy_refs" "$GIT_DIR" "$use_separate_remote" "$origin" ||
333 if test -z "$bare" && test -f "$GIT_DIR/REMOTE_HEAD"
335 # Figure out which remote branch HEAD points at.
336 case "$use_separate_remote" in
337 '') remote_top=refs/heads ;;
338 *) remote_top="refs/remotes/$origin" ;;
341 head_sha1=`cat "$GIT_DIR/REMOTE_HEAD"`
344 # Uh-oh, the remote told us (http transport done against
345 # new style repository with a symref HEAD).
346 # Ideally we should skip the guesswork but for now
347 # opt for minimum change.
348 head_sha1=`expr "z$head_sha1" : 'zref: refs/heads/\(.*\)'`
349 head_sha1=`cat "$GIT_DIR/$remote_top/$head_sha1"`
353 # The name under $remote_top the remote HEAD seems to point at.
357 cd "$GIT_DIR/$remote_top" &&
358 find . -type f -print | sed -e 's/^\.\///'
363 test t = $done && continue
364 branch_tip=`cat "$GIT_DIR/$remote_top/$name"`
365 if test "$head_sha1" = "$branch_tip"
374 # Write out remotes/$origin file, and update our "$head_points_at".
375 case "$head_points_at" in
377 mkdir -p "$GIT_DIR/remotes" &&
378 git-symbolic-ref HEAD "refs/heads/$head_points_at" &&
379 case "$use_separate_remote" in
380 t) origin_track="$remote_top/$head_points_at"
381 git-update-ref HEAD "$head_sha1" ;;
382 *) origin_track="$remote_top/$origin"
383 git-update-ref "refs/heads/$origin" "$head_sha1" ;;
385 echo >"$GIT_DIR/remotes/$origin" \
387 Pull: refs/heads/$head_points_at:$origin_track" &&
388 (cd "$GIT_DIR/$remote_top" && find . -type f -print) |
391 name=`expr "$dotslref" : './\(.*\)'`
392 if test "z$head_points_at" = "z$name"
396 if test "$use_separate_remote" = '' &&
397 test "z$origin" = "z$name"
401 echo "Pull: refs/heads/${name}:$remote_top/${name}"
402 done >>"$GIT_DIR/remotes/$origin" &&
403 case "$use_separate_remote" in
405 rm -f "refs/remotes/$origin/HEAD"
406 git-symbolic-ref "refs/remotes/$origin/HEAD" \
407 "refs/remotes/$origin/$head_points_at"
411 case "$no_checkout" in
413 git-read-tree -m -u -v HEAD HEAD
416 rm -f "$GIT_DIR/CLONE_HEAD" "$GIT_DIR/REMOTE_HEAD"